from vender.quant_api_base import base_Quant_api
import json


class Quant_api(base_Quant_api):


    def _rebalance(self, pt):
        # 此為範例

        # print out pt data
        print("------------ 此為 客戶portfolio ---------")
        print(json.dumps(pt, indent=2))

        print("------------ 此為 最新的投組推薦 ---------")
        model_portfolio = self.get_latest_portfolio(pt['recomm_id'])
        print(json.dumps(model_portfolio, indent=2))

        print("------------ 利用 rp_id 舊的投組推薦 ---------")
        print("rp_id = %s" % pt['rp_id'])
        model_portfolio2 = self.get_portfolio_by_rpid(pt['rp_id'])
        print(json.dumps(model_portfolio2, indent=2))
        if model_portfolio2['note'] != "":
            try:
                print("note JSON Object:")
                print(json.dumps(json.loads(model_portfolio2['note']), indent=2))
            except:
                None

        print("------------ 此為基金的分類（非必要）-------")
        for fund in model_portfolio['fws']:
            fund_id = fund['fund_id']
            fundclass = self.get_fund_asset_class(fund_id)
            print(fund_id + ": " ,fundclass)
        print("------------ 基金的分類（end）-------")

        ## ------- 返回結果 -------
        # 返回 model_portfolio 的 rp_id 表示需要 rebalance
        # 若是不需要 rebalance 返回 0
        return (model_portfolio['rp_id'], "判斷的理由")


    def _dividend(self, pt):
        # 此為範例

        # print out pt data
        print("****  dividend Called **** ")

        print("--- 此為 客戶portfolio (input data)---")
        print(json.dumps(pt, indent=2))

        '''
        Your core here...
        
        注意事項:
        因為排程是每日執行，若是要每月只執行一次，請以last_check_date判斷。
        為方便測試，若需取今日日期，請使用 warp function self.now()  
        '''
        print (f"--- 假設今日日期 :  {self.now()} " )

        ## ------- 返回結果 For example-------
        '''
        返回一個 list 
        每個 element 只少包含 fund_id, share,
        允許包含有其他自訂欄位
        '''
        print("--- 此為 回傳結果 ---")
        asset = pt['asset']
        return ( 
            {"fund_id" : f"{asset[0]['fund_id']}", "share" : f"{asset[0]['share']}" },  
            {"fund_id" : f"{asset[1]['fund_id']}", "share" : f"{asset[1]['share']}" },  
        )
